/*
 * $Id$
 */

package org.apache.maven.continuum.model.project.v1_0_9;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;
import org.apache.maven.continuum.model.scm.v1_0_9.ChangeFile;
import org.apache.maven.continuum.model.scm.v1_0_9.ChangeSet;
import org.apache.maven.continuum.model.scm.v1_0_9.ScmResult;
import org.apache.maven.continuum.model.scm.v1_0_9.SuiteResult;
import org.apache.maven.continuum.model.scm.v1_0_9.TestCaseFailure;
import org.apache.maven.continuum.model.scm.v1_0_9.TestResult;
import org.apache.maven.continuum.model.system.v1_0_9.NotificationAddress;
import org.apache.maven.continuum.model.system.v1_0_9.SystemConfiguration;

/**
 * null
 * 
 * @version $Revision$ $Date$
 */
public class ContinuumDatabase implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field projectGroups
     */
    private java.util.List projectGroups;

    /**
     * Field systemConfiguration
     */
    private SystemConfiguration systemConfiguration;

    /**
     * Field schedules
     */
    private java.util.List schedules;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addProjectGroup
     * 
     * @param projectGroup
     */
    public void addProjectGroup(ProjectGroup projectGroup)
    {
        if ( !(projectGroup instanceof ProjectGroup) )
        {
            throw new ClassCastException( "ContinuumDatabase.addProjectGroups(projectGroup) parameter must be instanceof " + ProjectGroup.class.getName() );
        }
        getProjectGroups().add( projectGroup );
    } //-- void addProjectGroup(ProjectGroup) 

    /**
     * Method addSchedule
     * 
     * @param schedule
     */
    public void addSchedule(Schedule schedule)
    {
        if ( !(schedule instanceof Schedule) )
        {
            throw new ClassCastException( "ContinuumDatabase.addSchedules(schedule) parameter must be instanceof " + Schedule.class.getName() );
        }
        getSchedules().add( schedule );
    } //-- void addSchedule(Schedule) 

    /**
     * Method getProjectGroups
     */
    public java.util.List getProjectGroups()
    {
        if ( this.projectGroups == null )
        {
            this.projectGroups = new java.util.ArrayList();
        }
        
        return this.projectGroups;
    } //-- java.util.List getProjectGroups() 

    /**
     * Method getSchedules
     */
    public java.util.List getSchedules()
    {
        if ( this.schedules == null )
        {
            this.schedules = new java.util.ArrayList();
        }
        
        return this.schedules;
    } //-- java.util.List getSchedules() 

    /**
     * Get null
     */
    public SystemConfiguration getSystemConfiguration()
    {
        return this.systemConfiguration;
    } //-- SystemConfiguration getSystemConfiguration() 

    /**
     * Method removeProjectGroup
     * 
     * @param projectGroup
     */
    public void removeProjectGroup(ProjectGroup projectGroup)
    {
        if ( !(projectGroup instanceof ProjectGroup) )
        {
            throw new ClassCastException( "ContinuumDatabase.removeProjectGroups(projectGroup) parameter must be instanceof " + ProjectGroup.class.getName() );
        }
        getProjectGroups().remove( projectGroup );
    } //-- void removeProjectGroup(ProjectGroup) 

    /**
     * Method removeSchedule
     * 
     * @param schedule
     */
    public void removeSchedule(Schedule schedule)
    {
        if ( !(schedule instanceof Schedule) )
        {
            throw new ClassCastException( "ContinuumDatabase.removeSchedules(schedule) parameter must be instanceof " + Schedule.class.getName() );
        }
        getSchedules().remove( schedule );
    } //-- void removeSchedule(Schedule) 

    /**
     * Set null
     * 
     * @param projectGroups
     */
    public void setProjectGroups(java.util.List projectGroups)
    {
        this.projectGroups = projectGroups;
    } //-- void setProjectGroups(java.util.List) 

    /**
     * Set null
     * 
     * @param schedules
     */
    public void setSchedules(java.util.List schedules)
    {
        this.schedules = schedules;
    } //-- void setSchedules(java.util.List) 

    /**
     * Set null
     * 
     * @param systemConfiguration
     */
    public void setSystemConfiguration(SystemConfiguration systemConfiguration)
    {
        this.systemConfiguration = systemConfiguration;
    } //-- void setSystemConfiguration(SystemConfiguration) 


    private String modelEncoding = "UTF-8";

    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    public String getModelEncoding()
    {
        return modelEncoding;
    }
}
