/*
 * $Id$
 */

package org.apache.maven.continuum.model.scm.v1_0_9;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;
import org.apache.maven.continuum.model.project.v1_0_9.BuildDefinition;
import org.apache.maven.continuum.model.project.v1_0_9.BuildResult;
import org.apache.maven.continuum.model.project.v1_0_9.ContinuumDatabase;
import org.apache.maven.continuum.model.project.v1_0_9.Project;
import org.apache.maven.continuum.model.project.v1_0_9.ProjectDependency;
import org.apache.maven.continuum.model.project.v1_0_9.ProjectDeveloper;
import org.apache.maven.continuum.model.project.v1_0_9.ProjectGroup;
import org.apache.maven.continuum.model.project.v1_0_9.ProjectNotifier;
import org.apache.maven.continuum.model.project.v1_0_9.Schedule;
import org.apache.maven.continuum.model.system.v1_0_9.NotificationAddress;
import org.apache.maven.continuum.model.system.v1_0_9.SystemConfiguration;

/**
 * null
 * 
 * @version $Revision$ $Date$
 */
public class TestResult implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field testCount
     */
    private int testCount = 0;

    /**
     * Field failureCount
     */
    private int failureCount = 0;

    /**
     * Field totalTime
     */
    private long totalTime = 0;

    /**
     * Field suiteResults
     */
    private java.util.List suiteResults;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addSuiteResult
     * 
     * @param suiteResult
     */
    public void addSuiteResult(SuiteResult suiteResult)
    {
        if ( !(suiteResult instanceof SuiteResult) )
        {
            throw new ClassCastException( "TestResult.addSuiteResults(suiteResult) parameter must be instanceof " + SuiteResult.class.getName() );
        }
        getSuiteResults().add( suiteResult );
    } //-- void addSuiteResult(SuiteResult) 

    /**
     * Get null
     */
    public int getFailureCount()
    {
        return this.failureCount;
    } //-- int getFailureCount() 

    /**
     * Method getSuiteResults
     */
    public java.util.List getSuiteResults()
    {
        if ( this.suiteResults == null )
        {
            this.suiteResults = new java.util.ArrayList();
        }
        
        return this.suiteResults;
    } //-- java.util.List getSuiteResults() 

    /**
     * Get null
     */
    public int getTestCount()
    {
        return this.testCount;
    } //-- int getTestCount() 

    /**
     * Get null
     */
    public long getTotalTime()
    {
        return this.totalTime;
    } //-- long getTotalTime() 

    /**
     * Method removeSuiteResult
     * 
     * @param suiteResult
     */
    public void removeSuiteResult(SuiteResult suiteResult)
    {
        if ( !(suiteResult instanceof SuiteResult) )
        {
            throw new ClassCastException( "TestResult.removeSuiteResults(suiteResult) parameter must be instanceof " + SuiteResult.class.getName() );
        }
        getSuiteResults().remove( suiteResult );
    } //-- void removeSuiteResult(SuiteResult) 

    /**
     * Set null
     * 
     * @param failureCount
     */
    public void setFailureCount(int failureCount)
    {
        this.failureCount = failureCount;
    } //-- void setFailureCount(int) 

    /**
     * Set null
     * 
     * @param suiteResults
     */
    public void setSuiteResults(java.util.List suiteResults)
    {
        this.suiteResults = suiteResults;
    } //-- void setSuiteResults(java.util.List) 

    /**
     * Set null
     * 
     * @param testCount
     */
    public void setTestCount(int testCount)
    {
        this.testCount = testCount;
    } //-- void setTestCount(int) 

    /**
     * Set null
     * 
     * @param totalTime
     */
    public void setTotalTime(long totalTime)
    {
        this.totalTime = totalTime;
    } //-- void setTotalTime(long) 


    private String modelEncoding = "UTF-8";

    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    public String getModelEncoding()
    {
        return modelEncoding;
    }
}
